﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Csla;
using Csla.Serialization;
using System.Data;
using System.Data.SqlClient;
using Csla.Data;

namespace Library.Rapport.Samling
{
    [Serializable]
    public class RapportKategoriInfo : ReadOnlyBase<RapportKategoriInfo>
    {

        #region " Business Properties and Methods "
        private static readonly PropertyInfo<bool> ValgtProperty = RegisterProperty<bool>(p => p.Valgt, "Valgt", true);
        public bool Valgt
        {
            get { return GetProperty(ValgtProperty); }
            private set { LoadProperty(ValgtProperty, value); }
        }

        private static readonly PropertyInfo<int> RAKRecProperty = RegisterProperty<int>(p => p.RAKRec, "Rec", 0);
        public int RAKRec
        {
            get { return GetProperty(RAKRecProperty); }
            internal set { LoadProperty(RAKRecProperty, value); }
        }

        private static readonly PropertyInfo<int> RAKNumberProperty = RegisterProperty<int>(p => p.RAKNumber, "Number");
        /// <summary>
        /// Unikt rekordnummer for tabellen RapportKategori
        /// </summary>
        public int RAKNumber
        {
            get { return GetProperty(RAKNumberProperty); }
            internal set { LoadProperty(RAKNumberProperty, value); }
        }

        private static readonly PropertyInfo<int> RAKPriorityProperty = RegisterProperty<int>(p => p.RAKPriority, "RAKPriority", 0);
        public int RAKPriority
        {
            get { return GetProperty(RAKPriorityProperty); }
            internal set { LoadProperty(RAKPriorityProperty, value); }
        }

        private static readonly PropertyInfo<string> RAKNavnProperty = RegisterProperty<string>(p => p.RAKNavn, "Navn");
        public string RAKNavn
        {
            get { return GetProperty(RAKNavnProperty); }
            internal set { LoadProperty(RAKNavnProperty, value); }
        }

        #endregion

        public override string ToString()
        {
            string S = null;
            S = GetProperty(RAKPriorityProperty).ToString();
            return S;
        }

        private void Child_Fetch(int RAKRec, int RAKNumber, int RAKPriority,string RAKNavn, bool Valgt)
        {
            LoadProperty(RAKRecProperty, RAKRec);
            LoadProperty(RAKNumberProperty, RAKNumber);
            LoadProperty(RAKPriorityProperty, RAKPriority);
            LoadProperty(RAKNavnProperty, RAKNavn);
            LoadProperty(ValgtProperty, Valgt);
        }

        private void Child_Fetch(SafeDataReader dr)
        {
            RAKRec = dr.GetInt32("RAKRec");
            RAKNumber = dr.GetInt32("RAKNumber");
            RAKPriority = dr.GetInt32("RAKPriority");
            RAKNavn = dr.GetString("RAKNavn");
        }

    }
}
