﻿using System;
using System.DirectoryServices.AccountManagement;
using System.Web.Hosting;
using Wisej.Web;
//using Library.MG;
//using Library.MG.Extensions;

namespace MGRptWebWisej
{
    public partial class MyDesktop : Desktop
    {
        public MyDesktop()
        {
            InitializeComponent();
        }

        private void MyDesktop_Load(object sender, EventArgs e)
        {
            //DoLogin(true);
        }

        #region " ApplyAuthorizationRules "


        private void ApplyAuthorizationRules()
        {

            System.Security.Principal.IPrincipal user = Csla.ApplicationContext.User;
            if (user.Identity.IsAuthenticated)
            {
                //MenyRegistre.Enabled = true;
                menuItemMain.Enabled = true;
                //HovedMenu.Enabled = true;
                panel1.Enabled = true;
            }
            else
            {
                //MenyRegistre.Enabled = false;
                menuItemMain.Enabled = false;
                //HovedMenu.Enabled = false;
                panel1.Enabled = false;
            }

            if (user.Identity.IsAuthenticated)
            {
                this.menuItemLogin.Text = "Logg ut";
                labelUser.Text = user.Identity.Name;
            }
            else
            {
                this.menuItemLogin.Text = "Logg inn";
                labelUser.Text = "Ingen pålogget";
            }
        }

        #endregion

        #region " Login "

        private System.Guid GetCurrentUserGuid()
        {
            Guid objectGuid;
            UserPrincipal adUser = null;
            try
            {
                using (HostingEnvironment.Impersonate())
                {
                    var userContext = System.Web.HttpContext.Current.User.Identity;
                    PrincipalContext ctx = new PrincipalContext(ContextType.Domain, "MGDC", null,
                        ContextOptions.Negotiate | ContextOptions.SecureSocketLayer);
                    adUser = UserPrincipal.FindByIdentity(ctx, userContext.Name);
                    objectGuid = (Guid)adUser.Guid;
                }
            }
            catch (Exception ex)
            {
                return Guid.Empty;
                //throw new Exception("Kunne ikke finne gjeldende AD bruker.", ex);
            }
            return objectGuid;
        }

        private void SetFormCaption()
        {
            this.Text = "MG Rapportregistrering " + Application.ProductVersion;
            System.Security.Principal.IPrincipal user = Csla.ApplicationContext.User;
            if (user.Identity.IsAuthenticated)
            {
                this.Text = this.Text + " [Bruker: " + user.Identity.Name + "]";
            }

            //if (Database.ButikkdataConnection.ToUpper().Contains("MGSQLSRV") && Database.ButikkdataConnection.ToUpper().Contains("=TEST"))
            //{
            //    this.Text = this.Text + " MOT MGSQL TESTDATABASE";
            //}
            //else if (Database.ButikkdataConnection.ToUpper().Contains("MGAPPTEST1"))
            //{
            //    this.Text = this.Text + " MOT MGAPPTEST1 TESTDATABASE";
            //}
            //else
            //{
            //    //Do nothing
            //}
        }

        private bool CloseAllForms()
        {

            while (Application.OpenForms.Count > 0)
            {
                int A = Application.OpenForms.Count;
                //this.ActivateMdiChild(this.MdiChildren(0));
                Application.OpenForms[0].Close();
                if (A == Application.OpenForms.Count)
                {
                    return false;
                }
            }
            return true;
        }

        #endregion

        #region " Menu "

        private void menuItemLogin_Click(object sender, EventArgs e)
        {
            try
            {
                //DoLogin();
            }
            catch (Exception ex)
            {
                //ErrorLog.Errormessage(ex);
                throw;
            }
        }

        private void menuItemRapporterHead_Click(object sender, EventArgs e)
        {
            try
            {
                //new MGRptWebWisej.RapportHeadForm.RapportHeadWindow().Show();
            }
            catch (Exception ex)
            {
                //ErrorLog.Errormessage(ex);
                throw;
            }
        }
        private void buttonMenyRapporter_Click(object sender, EventArgs e)
        {
            try
            {
                //new MGRptWebWisej.RapportHeadForm.RapportHeadWindow().Show();
            }
            catch (Exception ex)
            {
                throw;
                //ErrorLog.Errormessage(ex);
            }
        }

        private void menuItemCloseAll_Click(object sender, EventArgs e)
        {
            try
            {
                CloseAllForms();
            }
            catch (Exception ex)
            {
                throw;
                //ErrorLog.Errormessage(ex);
            }
        }

        private void menuItemKategorier_Click(object sender, EventArgs e)
        {
            try
            {
                new MGRptWebWisej.RapportKategoriForm.RapportKategoriWindow().Show();
            }
            catch (Exception ex)
            {
                throw;
                //ErrorLog.Errormessage(ex);
            }
        }

        private void buttonMenyKategorier_Click(object sender, EventArgs e)
        {
            try
            {
                new MGRptWebWisej.RapportKategoriForm.RapportKategoriWindow().Show();
            }
            catch (Exception ex)
            {
                throw;
                //ErrorLog.Errormessage(ex);
            }
        }

        private void buttonMenyRapporterListe_Click(object sender, EventArgs e)
        {
            try
            {
                //new MGRptWebWisej.RapportListe.RapportListeWindow().Show();
            }
            catch (Exception ex)
            {
                throw;
                //ErrorLog.Errormessage(ex);
            }
        }

        #endregion

    }
}
